using namespace std;
#include "cstr.h"
#include <string.h>
#include "extern_proto.h"
CStr::CStr() {
  pData = new char[1];
  *pData ='\0';
  nLength = 0;
}

CStr::CStr(char *s) {
  pData = new char[strlen(s)+1];
  strcpy(pData,s);
  nLength = strlen(s);
}

CStr::CStr(const CStr &s) {
  char* sz = s.get();
  int n = s.getlength();
  pData = new char[n+1];
  strcpy(pData,sz);
  nLength = n;
}

CStr::~CStr() {
  delete [] pData;
}

void CStr::cpy(char *s) {  // Copy string arg.
  int n;
  n = strlen(s);
  if (nLength != n) {
    if (pData)
      delete [] pData;
    pData = new char[n+1];
    nLength = n;
  }
  strcpy(pData,s);
}

void CStr::cat(char *s) {  // Concatenate string arg
  int n;
  char *pTemp;
  n = strlen(s);
  if (n == 0) return;
  pTemp = new char[n+nLength+1];
  if (pData) {
    strcpy(pTemp,pData);
    delete[] pData;
  }
  strcat(pTemp,s);
  pData = pTemp;
  nLength += n;
}

CStr operator+(CStr str1, CStr str2) {
  CStr new_string(str1);
  new_string.cat(str2.get());
  return new_string;
}

CStr operator+(CStr str, char *s) {
  CStr new_string(str);
  new_string.cat(s);
  return new_string;
}

CStr operator+(char *s, CStr str) {
  CStr new_string(s);
  new_string.cat(str.get());
  return new_string;
}
//

void vsetval(float *var, int n,float setval)
{  int j;
for (j=0;j<n;j++) {var[j]=setval;}
}

void vsetval(int *var, int n,int setval)
{  int j;
for (j=0;j<n;j++) {var[j]=setval;}
}
//

//cmp is used with the qsort function
int cmp(const void *p1, const void *p2) {
  float i = *(float *)p1; // Get ints pointed to.
  float j = *(float *)p2;
  return i<j?-1:(i==j?0:1);
}

